function finalSentenceVector = forwardPropTree(sNum,sTree,sStr,Wv,Wo,W,WO,Wcat,params, onlyGetVectors)

if ~exist('onlyGetVectors','var')
    onlyGetVectors = false;
end

wsz = params.wordSize;
r = params.rankWo;

words = find(sNum>0);
numTotalNodes = length(sNum);

allV = Wv(:,sNum(words));
allO = Wo(:,sNum(words));

thisTree = tree();
% set tree structure of tree
thisTree.pp = sTree';
% set which nodes are leaf nodes
thisTree.isLeafVec = zeros(numTotalNodes,1);
thisTree.isLeafVec(words) = 1;

thisTree.nodeNames = 1:length(sTree);
thisTree.nodeLabels = sNum;

% the inputs to the parent
thisTree.ParIn_z=zeros(params.wordSize,numTotalNodes); % empty for leaf nodes
thisTree.ParIn_a=zeros(params.wordSize,numTotalNodes);
% the new operators
thisTree.nodeOp_A=zeros(params.wordSize^2,numTotalNodes);
% the scores for each decision
thisTree.score = zeros(numTotalNodes,1);
% the children of each node (for speed)
thisTree.kids = zeros(numTotalNodes,2);

% initialize the vectors and operators of the words (leaf nodes)
thisTree.nodeAct_a(:,words) = allV;

for thisWordNum = 1:length(words)
    thisTree.nodeOp_A(:,thisWordNum) = reshape(diag(allO(1:wsz,thisWordNum))+reshape(allO(wsz+1:wsz*(1+r),thisWordNum),wsz,r)*...
        reshape(allO(wsz*(1+r)+1:end,thisWordNum),wsz,r)',wsz^2,1);
end

toMerge = words;

% new code till while loop start
finalSentenceVector = [];

while length(toMerge)>1
    % find unpaired bottom leaf pairs (initially words) that share parent
    i=0;
    foundGoodPair=0;
    while ~foundGoodPair
        i=i+1;
        if sTree(toMerge(i))==sTree(toMerge(i+1))
            foundGoodPair=1;
        end
    end
    newParent = sTree(toMerge(i));
    kid1 = toMerge(i);
    kid2 = toMerge(i+1);
    thisTree.kids(newParent,:) = [kid1 kid2];
    % set new parent to be possible merge candidate
    toMerge(i) = newParent;
    % delete other kid
    toMerge(i+1) = [];
    
    a = thisTree.nodeAct_a(:,kid1);
    A = reshape(thisTree.nodeOp_A(:,kid1),params.wordSize,params.wordSize);
    b = thisTree.nodeAct_a(:,kid2);
    B = reshape(thisTree.nodeOp_A(:,kid2),params.wordSize,params.wordSize);
    
    l_a = B*a;
    r_a = A*b;
    
    thisTree.nodeAct_a(:,newParent) = tanh(W * [l_a;r_a;1]);
    
    %new line of code (just 1)
    finalSentenceVector = tanh(W * [l_a;r_a;1]);

    P_A = reshape( WO * [A;B] ,params.wordSize^2,1);
    
    % save all this for backprop:
    thisTree.ParIn_a(:,kid1) = l_a;
    thisTree.ParIn_a(:,kid2) = r_a;
    thisTree.nodeOp_A(:,newParent) = P_A;
end

%new code till the beginning of the next comment block
finalSentenceVector;
