function F1 = test_without_external_features(Wv,Wo,W,WO,Wcat,params,type)
% If you'd like to load the SemEval task 8 data provided call:
%
% test_without_external_features(Wv,Wo,W,WO,Wcat,params,type)
% params - must have params.paths.data set to directory of SemEval data
% type - either 'test' or 'train' 
%
% You can also load specific files by calling 
%
% test_without_external_features(Wv,Wo,W,WO,Wcat,params)
% with params.paths.dataFile set to the file to load


if ~exist('type','var')
    type = [];
end

%new variable to hold all sentence vectors
allVectors = [];

% load testing data
[allSNum, allSStr, allSTree] = loadData(params,type);


if params.tinyDataSet, sentences = 1:10; else sentences = 1:length(allSNum); end

predictLabel = zeros(1,length(sentences));

counter = 0;

for s = sentences
    
    if mod(counter,200) == 0
        disp('done estimating sentence vectors for');
	counter
    end	

    senvec = forwardPropTree(allSNum{s},allSTree{s},allSStr{s}, ...
        Wv,Wo,W,WO,Wcat,params);

    %new code to find all sentence vectors
    allVectors = [allVectors,senvec];

    counter = counter + 1;    
    
end

save('allSentenceVectors.mat','allVectors');

disp('ALL SENTENCE VECTORS TOGETHER');
allVectors;

%F1 = getF1score(predictLabel,categories,sentenceLabels,'WOEF',params);
%if ~isempty(F1)
%    disp(['F1 score without external features is: ' num2str(F1)]);
%end

return
